--ZOBRAZENI I POLOZEK(Dodavatelu s mnozstvim) DO OBRAT. nebo POJ.ZASOBY
--Musi se zvolit spravne vuci cemu tedy kontrolujeme
--  a) Z.ZasobaPojistna
--  b) Z.ZasobaObratova

ALTER VIEW [dbo].[S5JET_OM2_ZpracGenObjVyd]
AS
SELECT  
CAST(LEFT(CAST(Sklad_ID AS varchar(max)), 24) + RIGHT(CAST(ISNULL(Firma_ID, '00000000-0000-0000-0000-000000000000') AS varchar(max)), 12) as uniqueidentifier) AS ID
,null as Parent_ID
,null as Root_ID
,null as Group_ID
,0 Deleted
,0 Locked
,0 Hidden
,null Create_ID
,cast('17530101' as datetime) Create_Date
,null Modify_ID
,null Modify_Date
,'<UserData />' as UserData
,Sklad_ID, Firma_ID, SUM(CelkovaCena) AS TotCena, SUM(DphZaklad) AS TotCenaBezDPH, SUM(ZbyvaObjednat) AS TotZbyvaObjednat
--Drive to bylo jen z polozek, ted i z chybejicich poj. zasob
--FROM S5JET_OM2_ZpracPolozky ZP WITH (NOLOCK)
FROM 
(
SELECT * FROM S5JET_OM2_ZpracPolozky WITH (NOLOCK)
UNION ALL
--Dotahnout vsechny zasoby co maji PredpokladaneMnozstvi(beru ze bude vzdy dorovnano do 0 (viz nahore) nebo vice) mensi nez Pojistnou
SELECT Z.ID AS Polozka_ID, Z.Sklad_ID, AD.Firma_ID
, (Z.ZasobaPojistna - CASE WHEN Z.PredpokladaneMnozstvi < 0 THEN 0 ELSE Z.PredpokladaneMnozstvi END) * A.PosledniCena AS CelkovaCena
, (Z.ZasobaPojistna - CASE WHEN Z.PredpokladaneMnozstvi < 0 THEN 0 ELSE Z.PredpokladaneMnozstvi END) * A.PosledniCena AS DphZaklad
, (Z.ZasobaPojistna - CASE WHEN Z.PredpokladaneMnozstvi < 0 THEN 0 ELSE Z.PredpokladaneMnozstvi END) AS ZbyvaObjednat
,Z.ID AS Zasoba_ID, Z.Nazev, A.ID AS Artikl_ID
FROM Sklady_Zasoba Z 
INNER JOIN Artikly_Artikl A WITH (NOLOCK) ON Z.Artikl_ID = A.ID 
LEFT JOIN Artikly_ArtiklDodavatel AD WITH (NOLOCK) ON A.HlavniDodavatel_ID = AD.ID 
WHERE (A.TypArtiklu = 0 OR A.TypArtiklu = 4) AND Z.Deleted <> 1
AND CASE WHEN Z.PredpokladaneMnozstvi < 0 THEN 0 ELSE Z.PredpokladaneMnozstvi END < Z.ZasobaPojistna
) AS ZP
GROUP BY Sklad_ID, Firma_ID
GO

